//+------------------------------------------------------------------+
//|                                          colored kama slope      |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property  indicator_separate_window
#property  indicator_buffers   5
#property  indicator_color1    Lime
#property  indicator_color2    Green
#property  indicator_color3    Red
#property  indicator_color4    Maroon
#property  indicator_color5    DarkGray
#property  indicator_width1    2
#property  indicator_width2    2
#property  indicator_width3    2
#property  indicator_width4    2
#property  indicator_width5    2
#property indicator_levelcolor Gold

//
//
//
//
//

extern string TimeFrame         = "Current time frame";
extern double AmaPeriod         = 50;
extern int    AmaPrice          = 0;
extern bool   Interpolate       = true;
extern bool   HistogramOnSlope  = true;

extern double upTrigger         = 0;
extern double dnTrigger         = 0;

extern string note              = "turn on Alert = true; turn off = false";
extern bool   alertsOn          = false;
extern bool   alertsOnSlope     = false;
extern bool   alertsOnZeroCross = false;
extern bool   alertsOnCurrent   = false;
extern bool   alertsMessage     = false;
extern bool   alertsSound       = false;
extern bool   alertsNotify      = false;
extern bool   alertsEmail       = false;

//
//
//
//
//

double kamahuu[];
double kamahud[];
double kamahdd[];
double kamahdu[];
double diff[];
double trend[];
double slope[];
double ama[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,kamahuu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,kamahud); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,kamahdd); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,kamahdu); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,diff);
   SetIndexBuffer(5,trend);
   SetIndexBuffer(6,slope);
   SetIndexBuffer(7,ama);
   SetLevelValue(0,0);
   SetLevelValue(1,upTrigger);
   SetLevelValue(2,dnTrigger);
   
      //
      //
      //
      //
      //

         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
         
      //
      //
      //
      //
      //
         
   IndicatorShortName(timeFrameToString(timeFrame)+  " KamaS");
return(0);
}
          
//
//
//
//
//

int deinit() { return(0);}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { kamahuu[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {     
      double pipValue = Point; if (Digits ==3 || Digits ==5) pipValue *= 10;
      for(i=limit; i>=0; i--) 
      {
         ama[i]   = iAma(iMA(NULL,0,1,0,MODE_SMA,AmaPrice,i),AmaPeriod,i,0);
         diff[i]  = (ama[i]-ama[i+1])/pipValue;
         
         //
         //
         //
         //
         //
         
         kamahuu[i] = EMPTY_VALUE;
         kamahud[i] = EMPTY_VALUE;
         kamahdd[i] = EMPTY_VALUE;
         kamahdu[i] = EMPTY_VALUE;
         trend[i]   = trend[i+1];
         slope[i]   = slope[i+1];

            if (diff[i] > 0)         trend[i] =  1;
            if (diff[i] < 0)         trend[i] = -1;
            if (diff[i] > diff[i+1]) slope[i] =  1;
            if (diff[i] < diff[i+1]) slope[i] = -1;
         
            if (HistogramOnSlope)
            {
              if (trend[i] ==  1 && slope[i] ==  1) kamahuu[i] = diff[i];
              if (trend[i] ==  1 && slope[i] == -1) kamahud[i] = diff[i];
              if (trend[i] == -1 && slope[i] == -1) kamahdd[i] = diff[i];
              if (trend[i] == -1 && slope[i] ==  1) kamahdu[i] = diff[i];
            }
            else
            {                  
              if (trend[i] ==  1) kamahuu[i] = diff[i];
              if (trend[i] == -1) kamahdd[i] = diff[i];
            }
    }      
  manageAlerts();
  return(0);
  }
      
  //
  //
  //
  //
  //
  
  limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
  for (i=limit;i>=0; i--)
  {
     int y = iBarShift(NULL,timeFrame,Time[i]);
        ama[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",AmaPeriod,AmaPrice,7,y);
        slope[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",AmaPeriod,AmaPrice,6,y);
        trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",AmaPeriod,AmaPrice,5,y);
        diff[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",AmaPeriod,AmaPrice,4,y);
        kamahuu[i] = EMPTY_VALUE;
        kamahud[i] = EMPTY_VALUE;
        kamahdd[i] = EMPTY_VALUE;
        kamahdu[i] = EMPTY_VALUE;
        
        if (HistogramOnSlope)
        {
          if (trend[i] ==  1 && slope[i] ==  1) kamahuu[i] = diff[i];
          if (trend[i] ==  1 && slope[i] == -1) kamahud[i] = diff[i];
          if (trend[i] == -1 && slope[i] == -1) kamahdd[i] = diff[i];
          if (trend[i] == -1 && slope[i] ==  1) kamahdu[i] = diff[i];
        }
        else
        {                  
          if (trend[i] ==  1) kamahuu[i] = diff[i];
          if (trend[i] == -1) kamahdd[i] = diff[i];
        }
        
        //
        //
        //
        //
        //
        
        if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
        
        //
        //
        //
        //
        //

        datetime time = iTime(NULL,timeFrame,y);
          for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
          for(int k = 1; k < n; k++)
          {
             diff[i+k] = diff[i] + (diff[i+n] - diff[i]) * k/n;
             if (kamahuu[i]!= EMPTY_VALUE) kamahuu[i+k] = diff[i+k];
             if (kamahud[i]!= EMPTY_VALUE) kamahud[i+k] = diff[i+k];
             if (kamahdd[i]!= EMPTY_VALUE) kamahdd[i+k] = diff[i+k];
             if (kamahdu[i]!= EMPTY_VALUE) kamahdu[i+k] = diff[i+k];
          }     
   }
   manageAlerts();
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workAma[][3];
#define _price 0
#define _diff  1
#define _ama   2
#define _fastend 0.666
#define _slowend 0.0645

double iAma(double price, int period, int i, int instanceNo)
{
   if (ArrayRange(workAma,0)!=Bars) ArrayResize(workAma,Bars); instanceNo *= 3; i=Bars-i-1; 
   
   //
   //
   //
   //
   //
   
      workAma[i][instanceNo+_price] = price;
      if (i<period)
      {
         if (i>0) 
               workAma[i][instanceNo+_diff] = MathAbs(price-workAma[i-1][instanceNo+_price]);
         else  workAma[i][instanceNo+_diff] = 0;
               workAma[i][instanceNo+_ama]  = price; 
         return(price);
      }
   
      //
      //
      //
      //
      //

      workAma[i][instanceNo+_diff] = MathAbs(price-workAma[i-1][instanceNo+_price]);
   			double efratio = 1;
            double signal  = MathAbs(workAma[i][instanceNo+_price]-workAma[i-period][instanceNo+_price]);
			   double noise   = workAma[i][instanceNo+_diff];
			   
			      for (int k=1; k<period && (i-k)>=0; k++) noise += workAma[i-k][instanceNo+_diff];
			      if (noise!= 0)
			          efratio = signal/noise;
			   double smooth  = MathPow(efratio*(_fastend-_slowend)+_slowend,2.0);
          workAma[i][instanceNo+_ama] = workAma[i-1][instanceNo+_ama]+smooth*(price-workAma[i-1][instanceNo+_ama]);
   return(workAma[i][instanceNo+_ama]);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnSlope && slope[whichBar] != slope[whichBar+1])
         {
            if (slope[whichBar] ==  1) doAlert(time1,mess1,whichBar," Kama slope changed to up");
            if (slope[whichBar] == -1) doAlert(time1,mess1,whichBar," Kama slope changed to down");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnZeroCross && trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] ==  1) doAlert(time2,mess2,whichBar," Kama Slope crossed zero line up");
            if (trend[whichBar] == -1) doAlert(time2,mess2,whichBar," Kama Slope crossed zero line down");
         }            
    }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  Symbol()+" "+timeFrameToString(timeFrame)+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Kama Slope " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Kama Slope "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}


